#include <string>

using namespace std;

int main()
{
    string str;
    cin >> str;
    int niz[26] = {0};
    int niz1[26], niz2[26];
    int n = str.length();
    int o = 0;
    while(str[o] == str[n-1-o] && o <= n/2-1) o++;
    //cout << o << endl;
    string s = str.substr(o, n-2*o);
    //cout << s << endl;
    n = s.length();
    int duzina1 = n;
    int duzina2 = n;
    for(int i = 0; i < n; i++) niz[s[i]-'a']++;
    for(int i = 0; i < 26; i++)
    {
        niz1[i] = niz[i]/2;
        niz2[i] = niz1[i];
    }
    //for(int i = 0; i < 26; i++) cout << niz2[i] << " ";cout << endl;
    //for(int i = 0; i < 26; i++) cout << niz1[i] << " ";cout << endl;
    for(int i = 0; i <= n/2-1; i++)
    {
        if(niz1[s[i]-'a'] == 0) break;
        else
        {
            duzina1--;
            niz1[s[i]-'a']--;
        }
    }
    for(int i = n-1-0; i >= n-n/2; i--)
    {
        if(niz2[s[i]-'a'] == 0) break;
        else
        {
            duzina2--;
            niz2[s[i]-'a']--;
        }
    }
    if(duzina1 == 0) duzina1++;
    if(duzina2 == 0) duzina2++;
    if(duzina1 < duzina2) cout << duzina1;
    else cout << duzina2;
    return 0;
}